<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <suspense-query :query="flatPageQuery" :delay-loading="500" transition="page">
    <!-- Loading -->
    <template #loading>
      <page-loading />
    </template>

    <!-- Error -->
    <template #error>
      <page-error :error="flatPageError" />
    </template>

    <!-- Data -->
    <template #data>
      <!-- Title -->
      <div class="studium-title">{{ flatPage.name }}</div>

      <!-- Last Updated -->
      <div class="studium-subtitle pb-4">{{ $t('flatpage.last') }}{{ lastUpdatedDate }}</div>

      <!-- Content -->
      <div v-dompurify-html="flatPage.content" />
    </template>
  </suspense-query>
</template>

<script lang="ts">
import { computed, defineComponent, useMeta } from '@nuxtjs/composition-api'
import { format, parseISO } from 'date-fns'

import { useFlatPageQuery } from '~/apollo/_generated'
import { useErrorHandler } from '~/util/composables'

export default defineComponent({
  props: {
    // URL of the flatpage
    url: {
      type: String,
      required: true,
    },
  },
  setup(props) {
    // Flat page query and content
    const flatPageQuery = useFlatPageQuery({ url: props.url })
    const flatPageError = useErrorHandler(flatPageQuery)
    const flatPage = computed(() => flatPageQuery.result.value?.flatPage)

    // Last updated date formatted
    const lastUpdatedDate = computed(() => {
      if (!flatPage?.value?.lastUpdatedDate) {
        return 'unknown date'
      }
      return format(parseISO(flatPage?.value.lastUpdatedDate), 'MMMM do, yyyy H:mm')
    })

    // SEO
    useMeta(() => ({ title: flatPage.value?.name ?? '' }))

    return {
      flatPageQuery,
      flatPageError,
      flatPage,
      lastUpdatedDate,
    }
  },

  // Empty head for useMeta
  head: {},
})
</script>
